// ----------------------------------------------------------------------^
// Copyright (C) 2004, 2005, 2006, 2007, 2008 Giorgio Calderone
// (mailto: <gcalderone@ifc.inaf.it>)
// 
// This file is part of MCS.
// 
// MCS is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// MCS is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with MCS; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
// 
// ----------------------------------------------------------------------$
#define MSG_LOG_COMMAND   0
#define MSG_OK   1
#define MSG_WELCOME   2
#define MSG_WELCOMEUSER   3
#define MSG_PASSWORD   4
#define MSG_DBNAME   5
#define MSG_DBHOST   6
#define MSG_CONNECTED   7
#define MSG_DB_ROWSAFF   8
#define MSG_SENDFILE_START   9
#define MSG_SENDDATA_START   10
#define MSG_RECVFILE_START   11
#define MSG_RECVDATA_START   12
#define MSG_FILE_STOP   13
#define MSG_DATA_STOP   14
#define MSG_OUT   15
#define MSG_WAKE_UP   16
#define MSG_USERTHREAD_TERMINATING   17
#define MSG_CLIENT_ID   18
#define MSG_BATCH_START   19
#define MSG_BATCH_STOP   20
#define MSG_DB_QRY_OK   21
#define MSG_SCRIPT_START   22
#define MSG_SCRIPT_STOP   23
#define MSG_SQL_START   24
#define MSG_SQL_STOP   25
#define MSG_DQR_START   26
#define MSG_DQR_STOP   27
#define MSG_DB_FIELDS_DESCR   28
#define MSG_DB_FIELDS_DESCR2   29
#define MSG_SYS_EXIT_STATUS   30
#define MSG_USER_HAS_GRANTS   31
#define MSG_THREAD_CREATE   32
#define MSG_THREAD_DESTROY   33
#define MSG_SERVER_DIR   34
#define MSG_SERVER_RUNNING   35
#define MSG_CREATING_LOCAL   36
#define MSG_CREATING_CLIENT   37
#define MSG_LOCAL_THREAD_DIED   38
#define MSG_KILLING_CLIENT   39
#define MSG_KILLING_LOCAL   40
#define MSG_KILLING_ALL_CLIENTS   41
#define MSG_COPYING_DATA_OBJECTS   42
#define MSG_NEW_RECORDSET   43
#define MSG_FETCH_EOF   44
#define MSG_BYE   49
#define MSG_DUMMY   50
#define MSG_CANT_OPEN_FILE   102
#define MSG_INVALID_SWITCH   103
#define MSG_METHOD_MUST_BE_OVERLOADED   104
#define MSG_NET_INTERFACE_NAME_NOT_EXISTS   105
#define MSG_NET_INTERFACE_ID_NOT_EXISTS   106
#define MSG_NET_INTERFACE_NOT_ACTIVE   107
#define MSG_RETRIEVING_INTERFACE_FLAGS   108
#define MSG_RETRIEVING_HOSTNAME   109
#define MSG_RETRIEVING_PEERNAME   110
#define MSG_RETRIEVING_HOST_INFO   111
#define MSG_CANT_CONNECT_TO_HOST   112
#define MSG_TIME_OUT   113
#define MSG_UNEXPECTED   114
#define MSG_CALLING_SELECT   116
#define MSG_CALLING_RECV   117
#define MSG_CALLING_SEND   118
#define MSG_CLOSED_BY_PEER   119
#define MSG_CALLING_BIND   120
#define MSG_CALLING_LISTEN   132
#define MSG_CALLING_PTHREAD_CREATE   133
#define MSG_OUT_OF_MEMORY   134
#define MSG_DIRECTORY_NOT_FOUND   135
#define MSG_CANT_MKDIR   136
#define MSG_CANT_RMDIR   137
#define MSG_CANT_MKFIFO   138
#define MSG_CALLING_PIPE   139
#define MSG_ERROR   200
#define MSG_SYNTAX   201
#define MSG_WRONG_DIM_SPEC   207
#define MSG_TYPE_NOT_HANDLED   208
#define MSG_CONVERSION_STRING_INT   209
#define MSG_CONVERSION_BLOB_INT   210
#define MSG_CONVERSION_STRING_FLOAT   211
#define MSG_CONVERSION_BLOB_FLOAT   212
#define MSG_CONVERSION_DATETIME   213
#define MSG_CONVERSION_BLOB_DATETIME   214
#define MSG_CONVERSION_INT_BLOB   215
#define MSG_CONVERSION_FLOAT_BLOB   216
#define MSG_CONVERSION_STRING_TOO_LONG   217
#define MSG_CONVERSION_STRING_BLOB   218
#define MSG_CONVERSION_TIME_LINT   219
#define MSG_CONVERSION_NAN   220
#define MSG_NOT_A_BLOB   221
#define MSG_BLOB_TOO_BIG   222
#define MSG_QUEUE_FULL   223
#define MSG_INDEX_OUT_RANGE   224
#define MSG_MISSING_FIELD   225
#define MSG_INDEX_UNAVAILABLE   226
#define MSG_ENTRY_UNAVAILABLE   227
#define MSG_INDEX_LT_ZERO   228
#define MSG_SEND_ABORT_BY_RECEIVER   229
#define MSG_PROTOCOL   230
#define MSG_NOT_ENOUGH_SPACE   231
#define MSG_CANT_ALLOCATE_MYSQL   232
#define MSG_CANT_OPEN_MYSQL_CONNECTION   233
#define MSG_USE_ONLY_WITH_STORERESULT   234
#define MSG_MYSQL_ERROR   235
#define MSG_INVALID_POSITION   236
#define MSG_BIND_FAILED   237
#define MSG_STMT_NOT_YET_PREPARED   238
#define MSG_EMPTY_STRING   239
#define MSG_CANT_GET_INFO_TABLE   240
#define MSG_CANT_LOCK_TABLE   241
#define MSG_CANT_UNLOCK_TABLE   242
#define MSG_STMT_WRONG_NUM_PARAM   243
#define MSG_NO_RESULT   244
#define MSG_NO_FIELDS   245
#define MSG_FITS_ERROR   250
#define MSG_FITS_NOT_COMPILED   251
#define MSG_UNKNOWN_FILE_TYPE   260
#define MSG_NOT_LOGIN   261
#define MSG_MYSQL_DISABLED   262
#define MSG_GRANTS_LOGIN   263
#define MSG_GRANTS_DB_SCRIPT   264
#define MSG_GRANTS_SCRIPT   265
#define MSG_GRANTS_QUERY   266
#define MSG_GRANTS_BATCH   267
#define MSG_GRANTS_ADMIN   268
#define MSG_GRANTS_GET   269
#define MSG_GRANTS_CANTGET_GRANTS   270
#define MSG_GRANTS_SYS   271
#define MSG_GRANTS_PUT   272
#define MSG_DB_ERR_NOTACTIVATED   273
#define MSG_DB_NOT_COMPILED   274
#define MSG_SCRIPT_ERROR   275
#define MSG_NO_MORE_CLIENT_ALLOWED   276
#define MSG_OBJECT_MISSING   277
#define MSG_SIZE_CHUNK   278
#define MSG_ALREADY_CONNECTED   279
#define MSG_EXT_BIN_UNEXPECTED   280
#define MSG_NOT_CONNECTED   281
#define MSG_EXT_NOT_AVAILABLE   282
#define MSG_CHARACTER_NOT_ALLOWED   283
#define MSG_CANT_SET_SYNCHRO_STATE   284
#define MSG_NOT_A_RANDOM_ACCESS_RECORDSET   285
#define MSG_ALREADY_AT_BEGIN_OF_FILE   286
#define MSG_ALREADY_AT_END_OF_FILE   287
#define MSG_NO_METAREC   288
#define MSG_DONT_KNOW_NROWS   291
#define MSG_NO_SAME_META_INFO   292
#define MSG_INSERT_NOT_ALLOWED   293
#define MSG_FETCH_ERROR   294
#define MSG_INCOMPATIBLE_SERIAL   295
#define MSG_CANT_READ_CERT   296
#define MSG_CANT_READ_KEY   297
#define MSG_SSL_CONNECT_ERROR   298
#define MSG_SSL_ACCEPT_ERROR   299
#define MSG_UNKNOWN_USERID   300
#define MSG_YET_RUNNING   301
#define MSG_FILE_ALREADY_EXISTS   302
#define MSG_PIPE_YET_OPENED   303
#define MSG_CANT_EXECUTE_FILE   304
#define MSG_CANT_BIND_AND_HAVE_DIMSPEC   305
#define MSG_TOO_MANY_DIMSPEC   306
#define MSG_VARYING_MUST_BE_LAST   307
#define MSG_NO_DIM_ALLOWED_TO_CHANGE   308
#define MSG_NO_ABSOLUTE_PATH   309
#define MSG_NO_DOUBLEDOT_PATH   310
#define MSG_CANT_FREE_EXTERNAL_BUF   311
#define MSG_NO_WINDOWS_SELECTED   312
#define MSG_PIPE_NOT_CREATED   313
#define MSG_VOT_UNHANDLED_CODE   400
#define MSG_VOT_PARSE_FAILED   401
#define MSG_VOT_CANT_OPEN_FILE   402
#define MSG_VOT_UNEXPECTED_NODE_TYPE   403
#define MSG_VOT_NOT_AN_INTEGER   404
#define MSG_VOT_INVALID_NODETYPE   405
#define MSG_VOT_INVALID_DATATYPE   406
#define MSG_VOT_INVALID_ENCODINGTYPE   407
#define MSG_VOT_INVALID_RESOURCE_TYPE   408
#define MSG_VOT_INVALID_FIELD_TYPE   409
#define MSG_VOT_INVALID_VALUES_TYPE   410
#define MSG_VOT_INVALID_LINK_CONTENT_ROLE   411
#define MSG_VOT_INVALID_STREAM_TYPE   412
#define MSG_VOT_INVALID_STREAM_ACTUATE   413
#define MSG_VOT_INVALID_COOSYS_SYSTEM   414
#define MSG_VOT_INVALID_INDEX   415
#define MSG_VOT_UNEXPECTED_ATTRIBUTE   416
#define MSG_VOT_ROOT_IS_NOT_VOTABLE   417
#define MSG_CURL_ERROR   500
#define MSG_CURL_INIT   501
#define MCS_LAST_MESSAGE_CODE 50
#define MCS_LAST_ERROR_CODE 501
